Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/f005pc.hagenberg.fhooe.at - app.config
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/f005pc.hagenberg.fhooe.at - app.config	(revision 5153)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/f005pc.hagenberg.fhooe.at - app.config	(revision 5153)
@@ -0,0 +1,41 @@
+<?xml version="1.0"?>
+<configuration>
+  <configSections>
+  </configSections>
+  <system.serviceModel>
+    <bindings>
+      <netTcpBinding>
+        <binding name="SlaveTcpStreamedEndpoint" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00" transactionFlow="false" transferMode="Streamed" transactionProtocol="OleTransactions" hostNameComparisonMode="StrongWildcard" listenBacklog="10" maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10" maxReceivedMessageSize="104857600">
+          <readerQuotas maxDepth="32" maxStringContentLength="104857600" maxArrayLength="104857600" maxBytesPerRead="4096" maxNameTableCharCount="16384"/>
+          <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false"/>
+          <security mode="TransportWithMessageCredential">
+            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign"/>
+            <message clientCredentialType="UserName" algorithmSuite="Default"/>
+          </security>
+        </binding>
+      </netTcpBinding>
+      <wsHttpBinding>
+        <binding name="SlaveHttpEndpoint" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="524288" maxReceivedMessageSize="104857600" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+          <readerQuotas maxDepth="32" maxStringContentLength="104857600" maxArrayLength="104857600" maxBytesPerRead="104857600" maxNameTableCharCount="104857600"/>
+          <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false"/>
+          <security mode="Message">
+            <transport clientCredentialType="Windows" proxyCredentialType="None" realm=""/>
+            <message clientCredentialType="UserName" negotiateServiceCredential="true" algorithmSuite="Default"/>
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    <client>
+      <endpoint address="http://f005pc.hagenberg.fhooe.at:9000/Hive-3.3/SlaveService.svc" binding="wsHttpBinding" bindingConfiguration="SlaveHttpEndpoint" contract="SlaveFacade.ISlaveFacade" name="SlaveHttpEndpoint">
+        <identity>
+          <certificate encodedValue="AwAAAAEAAAAUAAAAfEKvcVixnJay+q4hCPFuO0JL5TQgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMTAxOTEwNTMxNVoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDXwC5TGcAffd/0oAWHtm0s6YXVXEgXgb1AYmBkkkhkKIFJG/e/Z0KSYbJepmSJD44W3oOAVm+x1DAsZxU79HahDYgWCuHLMm1TLpwSmYOQ0kV3pGHWHhiWV7h7oGLds/eqZ2EOpaNGryfEPnrA4VmxY91vV5/2BTeVSWG6F8lRKQIDAQABo0kwRzBFBgNVHQEEPjA8gBAR7kBnMRHO5gzThEqda0wWoRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQADgYEAoPwEG4QTDXhlxERNDfsZmM2IhEpV42ppz1kEah2oYKDa/ElIMVtvqLv6flVtg18ENN/mEJWiHZ3NyP3qr2Pip+sh+/2WBiSbOaukES/CM7OJn9kJCImH7M/xqM8pxqY8IfgM6iBVrVj9uHqj3j2BBck+cYY8fKyh3CFifMIp6ac=" />
+        </identity>
+      </endpoint>
+      <endpoint address="net.tcp://f005pc.hagenberg.fhooe.at:9001/Hive-3.3/SlaveService.svc" binding="netTcpBinding" bindingConfiguration="SlaveTcpStreamedEndpoint" contract="SlaveFacade.ISlaveFacade" name="SlaveTcpStreamedEndpoint">
+        <identity>
+          <dns value="localhost"/>
+        </identity>
+      </endpoint>
+    </client>
+  </system.serviceModel>
+<startup><supportedRuntime version="v2.0.50727"/></startup></configuration>
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 5152)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 5153)
@@ -141,6 +141,5 @@
             catch (AppDomainUnloadedException) {
               // appdomain already unloaded. Finishing job probably ongoing
-            }
-          else
+            } else
             Logger.Error("AbortJob: Engine doesn't exist");
           break;
@@ -291,5 +290,5 @@
 
         byte[] sJob = engines[jId].GetFinishedJob();
-        
+
         try {
           Logger.Info("Sending the finished job with id: " + jId);
@@ -384,10 +383,13 @@
             AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(e.Result.Obj.Id.ToString(), pluginDir, Path.Combine(pluginDir, PluginCache.ConfigFileName));
             appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
-            lock (engines) {
-              if (!jobs.ContainsKey(e.Result.Obj.Id)) {
-                jobs.Add(e.Result.Obj.Id, e.Result.Obj);
-                appDomains.Add(e.Result.Obj.Id, appDomain);
-                Logger.Debug("Creating AppDomain");
-                Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
+
+            if (!jobs.ContainsKey(e.Result.Obj.Id)) {
+              jobs.Add(e.Result.Obj.Id, e.Result.Obj);
+              appDomains.Add(e.Result.Obj.Id, appDomain);
+              Logger.Debug("Creating AppDomain");
+
+              Executor engine;
+              lock (engines) {
+                engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
                 Logger.Debug("Created AppDomain");
                 engine.JobId = e.Result.Obj.Id;
@@ -395,8 +397,8 @@
                 Logger.Debug("Starting Engine for job " + e.Result.Obj.Id);
                 engines.Add(e.Result.Obj.Id, engine);
-                engine.Start(e.Data);
-                SlaveStatusInfo.JobsFetched++;
-                Logger.Info("Increment FetchedJobs to:" + SlaveStatusInfo.JobsFetched);
               }
+              SlaveStatusInfo.JobsFetched++;
+              Logger.Info("Increment FetchedJobs to:" + SlaveStatusInfo.JobsFetched);
+              engine.Start(e.Data);
             }
             heartbeatManager.AwakeHeartBeatThread();
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 5152)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 5153)
@@ -79,5 +79,7 @@
           ));
         } else {
-          Job.Prepare();
+          if(Job.ExecutionState == Core.ExecutionState.Stopped)
+            Job.Prepare();
+          
           Job.Start();
         }
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj	(revision 5152)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj	(revision 5153)
@@ -32,4 +32,10 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="HeuristicLab.Clients.Common-3.3">
@@ -48,4 +54,16 @@
       <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Core.Views-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Core.Views-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.MainForm-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization.Views-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Optimization.Views-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Persistence-3.3">
       <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Persistence-3.3.dll</HintPath>
@@ -53,4 +71,7 @@
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Random-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Random-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.SequentialEngine-3.3">
@@ -60,4 +81,5 @@
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -67,4 +89,11 @@
   <ItemGroup>
     <Compile Include="ScopeMergeException.cs" />
+    <Compile Include="Views\HiveEngineView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\HiveEngineView.Designer.cs">
+      <DependentUpon>HiveEngineView.cs</DependentUpon>
+    </Compile>
+    <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
     <None Include="HeuristicLabHiveEnginePlugin.cs.frame" />
@@ -92,4 +121,9 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Views\HiveEngineView.resx">
+      <DependentUpon>HiveEngineView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 5152)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 5153)
@@ -13,4 +13,5 @@
 using HeuristicLab.Hive.Contracts.ResponseObjects;
 using System.Threading;
+using HeuristicLab.Random;
 
 namespace HeuristicLab.HiveEngine {
@@ -19,14 +20,22 @@
   /// </summary>
   [StorableClass]
-  [Item("Hive Parallel Engine", "Engine for parallel execution on the hive.")]
+  [Item("Hive Engine", "Engine for parallel execution on the hive. You need enable `Parallel` for at least one operator in your operator graph to have all childoperations parallelized. Also those childoperations must not have sideeffects on a higher scope.")]
   public class HiveEngine : Engine {
+    [Storable]
     private IOperator currentOperator;
 
+    [Storable]
+    public string ResourceIds { get; set; }
+
     #region constructors and cloning
-    public HiveEngine() { }
+    public HiveEngine() {
+      ResourceIds = "HEAL";
+    }
     [StorableConstructor]
     protected HiveEngine(bool deserializing) : base(deserializing) { }
     protected HiveEngine(HiveEngine original, Cloner cloner)
       : base(original, cloner) {
+      this.ResourceIds = original.ResourceIds;
+      this.currentOperator = cloner.Clone(original.currentOperator);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -42,8 +51,17 @@
       while (coll != null) {
         if (coll.Parallel) {
-          IScope scope = ((IAtomicOperation)coll.Where(x => x is IAtomicOperation).First()).Scope;
-          IEnumerable<IOperation> finishedOperations = ExecuteOnHive(coll.Select(op => new OperationJob(op)));
-          foreach (IOperation op in finishedOperations) {
-            ReIntegrateScope(scope, op);
+          IDictionary<IOperation, OperationJob> jobs = new Dictionary<IOperation, OperationJob>();
+          foreach (IOperation op in coll) {
+            jobs.Add(op, new OperationJob(op));
+          }
+
+          ExecuteOnHive(jobs);
+
+          foreach (var kvp in jobs) {
+            if (kvp.Key is IAtomicOperation) {
+              ReIntegrateScope(kvp.Value.Operation as IAtomicOperation, kvp.Key as IAtomicOperation);
+            } else if (kvp.Key is OperationCollection) {
+              // todo
+            }
           }
         } else {
@@ -73,62 +91,50 @@
     }
 
-    private static void ReIntegrateScope(IScope scope, IOperation operation) {
-      if (operation is IAtomicOperation) {
-        MergeScopes(scope, ((IAtomicOperation)operation).Scope);
-      } else if (operation is OperationCollection) {
-        foreach (IOperation op in (OperationCollection)operation) {
-          ReIntegrateScope(scope, op);
+    private IRandom FindRandomParameter(IExecutionContext ec) {
+      try {
+        if (ec == null)
+          return null;
+
+        foreach (var p in ec.Parameters) {
+          if (p.Name == "Random" && p is IValueParameter)
+            return ((IValueParameter)p).Value as IRandom;
         }
+        return FindRandomParameter(ec.Parent);
       }
+      catch { return null; }
     }
 
-    private static void MergeScopes(IScope target, IScope source) {
-      foreach (IVariable variable in source.Variables) {
-        if (target.Variables.ContainsKey(variable.Name)) {
-          if (target.Variables[variable.Name] != source.Variables[variable.Name]) {
-            // problem: ResultCollection are not equal altough they contain the same values.
-            //             - either implement ResultCollection.Equals, or consider ResultCollection as special case here
-            //throw new ScopeMergeException(string.Format("Variable {0} already exists in target scope and has a different value ({1}, {2}).", variable.Name, target.Variables[variable.Name].Value, variable.Value));
-          }
-        } else {
-          target.Variables.Add(variable);
-        }
-      }
-
-      //this is not useful on the parentscope of the initial scope
-      //foreach (IScope subScope in source.SubScopes) {
-      //  target.SubScopes.Add(subScope);
-      //}
-
-      if (target.Parent != null && source.Parent != null)
-        MergeScopes(target.Parent, source.Parent);
+    private static void ReIntegrateScope(IAtomicOperation source, IAtomicOperation target) {
+      ExchangeScope(source.Scope, target.Scope);
     }
 
-
-    private IEnumerable<IOperation> TestExecuteOnHive(IEnumerable<OperationJob> operationJobs) {
-      //var clonedJobs = operationJobs.Select(x => (OperationJob)x.Clone()).ToArray();
-      var results = new List<IOperation>();
-
-      foreach (var job in operationJobs) {
-        job.Start();
-        while (job.ExecutionState != Core.ExecutionState.Stopped) {
-          Thread.Sleep(100);
-        }
-        results.Add(job.Operation);
-      }
-      return results;
+    private static void ExchangeScope(IScope source, IScope target) {
+      target.Variables.Clear();
+      target.Variables.AddRange(source.Variables);
+      target.SubScopes.Clear();
+      target.SubScopes.AddRange(source.SubScopes);
+      // TODO: validate if parent scopes match - otherwise source is invalid
     }
 
-    private IEnumerable<IOperation> ExecuteOnHive(IEnumerable<OperationJob> operationJobs) {
-      IEnumerable<Guid> jobIds;
+    /// <summary>
+    /// This method blocks until all jobs are finished
+    /// </summary>
+    /// <param name="jobDict"></param>
+    private void ExecuteOnHive(IDictionary<IOperation, OperationJob> jobDict) {
+      Log.LogMessage(string.Format("Executing {0} operations on the hive.", jobDict.Count));
+      IDictionary<Guid, IOperation> jobIds = new Dictionary<Guid, IOperation>();
       JobResultList results;
-
 
       using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
         List<JobDto> jobs = new List<JobDto>();
-        foreach (OperationJob operationJob in operationJobs) {
-          var groups = new string[] { "HEAL" };
+        foreach (var kvp in jobDict) {
+          // shuffle random variable to avoid the same random sequence in each operation
+          IRandom random = FindRandomParameter(kvp.Key as IExecutionContext);
+          if (random != null)
+            random.Reset(random.Next());
+
+          var groups = ResourceIds.Split(';');
           SerializedJob serializedJob = new SerializedJob();
-          serializedJob.SerializedJobData = SerializedJob.Serialize(operationJob);
+          serializedJob.SerializedJobData = SerializedJob.Serialize(kvp.Value);
           serializedJob.JobInfo = new JobDto();
           serializedJob.JobInfo.State = JobState.Offline;
@@ -137,7 +143,7 @@
           ResponseObject<JobDto> response = service.Obj.AddJobWithGroupStrings(serializedJob, groups);
           jobs.Add(response.Obj);
+          jobIds.Add(response.Obj.Id, kvp.Key);
         }
-        jobIds = jobs.Select(x => x.Id);
-        results = service.Obj.GetJobResults(jobIds).Obj;
+        results = service.Obj.GetJobResults(jobIds.Keys).Obj;
       }
 
@@ -148,22 +154,25 @@
         Thread.Sleep(5000);
         using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-          results = service.Obj.GetJobResults(jobIds).Obj;
+          results = service.Obj.GetJobResults(jobIds.Keys).Obj;
         }
       }
 
       // all finished
-      List<OperationJob> finishedJobs = new List<OperationJob>();
       using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-        foreach (Guid jobId in jobIds) {
+        foreach (Guid jobId in jobIds.Keys) {
           SerializedJob serializedJob = service.Obj.GetLastSerializedResult(jobId).Obj;
           OperationJob operationJob = SerializedJob.Deserialize<OperationJob>(serializedJob.SerializedJobData);
-          finishedJobs.Add(operationJob);
+          jobDict[jobIds[jobId]] = operationJob;
         }
       }
 
       // delete jobs
-      // TODO
+      using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+        foreach (Guid jobId in jobIds.Keys) {
+          service.Obj.DeleteJob(jobId);
+        }
+      }
 
-      return finishedJobs.Select(x => x.Operation);
+      Log.LogMessage(string.Format("Operations on the hive finished.", jobDict.Count));
     }
 
@@ -176,4 +185,5 @@
       if (currentOperator != null) currentOperator.Abort();
     }
+
   }
 }
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs	(revision 5153)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs	(revision 5153)
@@ -0,0 +1,75 @@
+﻿namespace HeuristicLab.HiveEngine.Views {
+  partial class HiveEngineView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.resourceIdsLabel = new System.Windows.Forms.Label();
+      this.resourceIdsTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // logView
+      // 
+      this.logView.Location = new System.Drawing.Point(0, 49);
+      this.logView.Size = new System.Drawing.Size(430, 302);
+      // 
+      // resourceIdsLabel
+      // 
+      this.resourceIdsLabel.AutoSize = true;
+      this.resourceIdsLabel.Location = new System.Drawing.Point(3, 26);
+      this.resourceIdsLabel.Name = "resourceIdsLabel";
+      this.resourceIdsLabel.Size = new System.Drawing.Size(70, 13);
+      this.resourceIdsLabel.TabIndex = 3;
+      this.resourceIdsLabel.Text = "ResourceIds:";
+      // 
+      // resourceIdsTextBox
+      // 
+      this.resourceIdsTextBox.Location = new System.Drawing.Point(73, 23);
+      this.resourceIdsTextBox.Name = "resourceIdsTextBox";
+      this.resourceIdsTextBox.Size = new System.Drawing.Size(357, 20);
+      this.resourceIdsTextBox.TabIndex = 4;
+      this.resourceIdsTextBox.Text = "HEAL";
+      this.resourceIdsTextBox.TextChanged += new System.EventHandler(this.resourceIdsTextBox_TextChanged);
+      // 
+      // HiveEngineView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.resourceIdsTextBox);
+      this.Controls.Add(this.resourceIdsLabel);
+      this.Name = "HiveEngineView";
+      this.Controls.SetChildIndex(this.resourceIdsLabel, 0);
+      this.Controls.SetChildIndex(this.resourceIdsTextBox, 0);
+      this.Controls.SetChildIndex(this.logView, 0);
+      this.Controls.SetChildIndex(this.executionTimeLabel, 0);
+      this.Controls.SetChildIndex(this.executionTimeTextBox, 0);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label resourceIdsLabel;
+    private System.Windows.Forms.TextBox resourceIdsTextBox;
+  }
+}
Index: /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs	(revision 5153)
+++ /branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs	(revision 5153)
@@ -0,0 +1,65 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization.Views;
+using HeuristicLab.Core.Views;
+
+namespace HeuristicLab.HiveEngine.Views {
+  [View("Hive Engine View")]
+  [Content(typeof(HiveEngine), IsDefaultView = true)]
+  public sealed partial class HiveEngineView : EngineView {
+    public new HiveEngine Content {
+      get { return (HiveEngine)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public HiveEngineView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      // TODO: Deregister your event handlers here
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      // TODO: Register your event handlers here
+    }
+
+    #region Event Handlers (Content)
+    // TODO: Put event handlers of the content here
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        // TODO: Add code when content has been changed and is null
+      } else {
+        // TODO: Add code when content has been changed and is not null
+      }
+    }
+
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      // Enable or disable controls based on whether the content is null or the view is set readonly
+      if (Content != null) {
+        resourceIdsTextBox.ReadOnly = this.ReadOnly;
+      } else {
+        resourceIdsTextBox.ReadOnly = false;
+      }
+    }
+    
+    #region Event Handlers (child controls)
+    private void resourceIdsTextBox_TextChanged(object sender, EventArgs e) {
+      Content.ResourceIds = resourceIdsTextBox.Text;
+    }
+    #endregion
+  }
+}
